<?php

namespace common\modules\bids\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\modules\bids\models\Bid;

/**
 * SearchBid represents the model behind the search form about `common\modules\bids\models\Bid`.
 */
class SearchBid extends Bid
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['name', 'phone', 'email', 'filename', 'text', 'created_at', 'form'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Bid::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'form' => $this->form,
            'created_at' => ($this->created_at?strtotime($this->created_at):$this->created_at),
        ]);

        $query->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'phone', $this->phone])
            ->andFilterWhere(['like', 'email', $this->email])
            ->andFilterWhere(['like', 'filename', $this->filename])
            ->andFilterWhere(['like', 'text', $this->text]);

        return $dataProvider;
    }
}
